/* ---------------------------------------------------------------
 * Arduino sketch name: part_4_multiple_bytes
 * File name:           part_4_multiple_bytes.ino
 * Author name:         Ian Grout
 * Last updated on:     13th March 2024
 * --------------------------------------------------------------- */

/* --------------------------------------------
 * Code required before setup function
 * -------------------------------------------- */

#define ON_BOARD_LED 2

String  input_string     = "";
boolean string_complete  = false;

 /* -------------------------------------------------
 * void setup( void )
 * ------------------------------------------------- */
 
 void setup( void )
 {
   
   pinMode( ON_BOARD_LED, OUTPUT );
   digitalWrite( ON_BOARD_LED, LOW );
   
   Serial.begin( 9600 );

}

/* -------------------------------------------------
 * void loop( void )
 * ------------------------------------------------- */

void loop( void )
{
  
  serial_event();

  if ( string_complete )
  {
    Serial.print( "String received: " );
    Serial.println( input_string );
    
    digitalWrite( ON_BOARD_LED, !digitalRead( ON_BOARD_LED ) );
    
    input_string    = "";
    string_complete = false;           
  } else
  {
  }
  
}

/* -------------------------------------------------
 * void serial_event( void )
 * ------------------------------------------------- */
 
void serial_event( void )
{
  
  while ( Serial.available() )
  {
    
    char in_char = ( char )Serial.read();
    input_string += in_char;

    if ( in_char == '\n' )
    {
      string_complete = true;
    }
    
  }

}

/* ---------------------------------------------------------------
 * End of file
 * --------------------------------------------------------------- */
 