/* ---------------------------------------------------------------
 * Arduino sketch name: part_4_single_byte
 * File name:           part_4_single_byte.ino
 * Author name:         Ian Grout
 * Last updated on:     13th March 2024
 * --------------------------------------------------------------- */

/* --------------------------------------------
 * Code required before setup function
 * -------------------------------------------- */
 
 #define ON_BOARD_LED 2
 
 int incomingByte = 0;

 /* -------------------------------------------------
 * void setup( void )
 * ------------------------------------------------- */
 
 void setup( void )
 {
   
   pinMode( ON_BOARD_LED, OUTPUT );
   digitalWrite( ON_BOARD_LED, LOW );
   
   Serial.begin( 9600 );

}

/* -------------------------------------------------
 * void loop( void )
 * ------------------------------------------------- */

void loop( void )
{

  if ( Serial.available() > 0 )
  {
    incomingByte = Serial.read();
    Serial.print( "Byte received: " );
    Serial.println( incomingByte );
    Serial.print( "Byte received: " );
    Serial.println( char( incomingByte ) );    
    Serial.print( "Byte received ASCII code decimal: " );
    Serial.println( incomingByte, DEC );
    Serial.print( "Byte received ASCII code hexadecimal: " );    
    Serial.println( incomingByte, HEX );
    
    digitalWrite( ON_BOARD_LED, !digitalRead( ON_BOARD_LED ) ); 
  }

}

/* ---------------------------------------------------------------
 * End of file
 * --------------------------------------------------------------- */
 