/* ---------------------------------------------------------------
 * Arduino sketch name: part_5
 * File name:           part_5.ino
 * Author name:         Ian Grout
 * Last updated on:     13th March 2024
 * --------------------------------------------------------------- */

/* --------------------------------------------
 * Code required before setup function
 * -------------------------------------------- */

#define ON_BOARD_LED 2

String  input_string     = "";
boolean string_complete  = false;

char *token_ptr;
uint8_t token_counter = 0;
  
/* -------------------------------------------------
 * void setup( void )
 * ------------------------------------------------- */
 
void setup( void )
{

  pinMode( ON_BOARD_LED, OUTPUT );
  digitalWrite( ON_BOARD_LED, LOW );

  Serial.begin( 9600 );
  while ( !Serial )
  {
    digitalWrite( ON_BOARD_LED, HIGH );
    delay( 500 );
    digitalWrite( ON_BOARD_LED, LOW );
    delay( 500 );
  }
  Serial.flush();

  Serial.println( "---------------------------------" );
  Serial.println( "-- part_5" );  
  Serial.println( "---------------------------------" );
  
}

/* -------------------------------------------------
 * void loop( void )
 * ------------------------------------------------- */

void loop( void )
{

  float calculation_result = 0.0;
  float a = 0.0;
  float b = 0.0;
  float x = 0.0;

  serial_event();

  /* ------------------------------------------------------- */
  
  if ( string_complete && ( input_string.startsWith( "calculate(" ) ) && ( input_string.endsWith( ")\n" ) ) )
  {
    
    int str_len = input_string.length() + 1;
    char char_array[str_len];

    Serial.println( "-- Start ------" );
    Serial.println( input_string );
    Serial.println( str_len );
    input_string.replace( "calculate(", "" );
    input_string.replace( " ", "" );    
    input_string.replace( ")\n", "" );
    Serial.println( input_string );
    
    input_string.toCharArray( char_array, str_len );
    token_ptr = strtok( char_array, "," );
    token_counter = 0;
    
    while ( token_ptr !=NULL )
    {
      Serial.println( token_ptr );
      if ( token_counter==0 )
      {        
        a = atof( token_ptr );
               
      } else if ( token_counter==1 )
      {
        b = atof( token_ptr );
           
      } else if ( token_counter==2 )
      {
        x = atof( token_ptr );             
      } else
      {      
      }
      token_counter = token_counter + 1;
      token_ptr = strtok( NULL, "," );
    }
        
    calculation_result = calculation( a, b, x );

    Serial.print( "x = " );
    Serial.print( x );    
    Serial.print( " a = " );
    Serial.print( a );
    Serial.print( " b = " );
    Serial.print( b );
    Serial.print( " y = " );    
    Serial.println( calculation_result );
    Serial.println( "-- End --------" );
        
    digitalWrite( ON_BOARD_LED, !digitalRead( ON_BOARD_LED ) );

    input_string    = "";
    string_complete = false;
     
/* ------------------------------------------------------- */

  } else if ( string_complete )
  {

    Serial.println( "Incorrect value received" );
    Serial.println( input_string );

    input_string    = "";
    string_complete = false;

  /* ------------------------------------------------------- */
     
  } else
  {
  } 
 
  /* ------------------------------------------------------- */

}

/* ---------------------------------------------------------------
 * End of file
 * --------------------------------------------------------------- */
